// ===========================================================================
//	LOffscreenBufferPane.cp				   1993-1997 eli curtz. All rights reserved.
// ===========================================================================
//

#ifdef PowerPlant_PCH
#include PowerPlant_PCH
#endif

#include <LPicture.h>
#include <LStream.h>
#include <UDrawingState.h>

#include <UGWorld.h>

#include "LOffscreenBufferPane.h"

// ---------------------------------------------------------------------------
//	 CreateStream(LStream*)						Static Constructor		  [public]
// ---------------------------------------------------------------------------

LOffscreenBufferPane*
LOffscreenBufferPane::CreateStream(
	LStream* inStream)
{
	return new LOffscreenBufferPane(inStream);
}

// ---------------------------------------------------------------------------
//	 LOffscreenBufferPane						Default Constructor		  [public]
// ---------------------------------------------------------------------------

LOffscreenBufferPane::LOffscreenBufferPane()
{
	mGWorld = nil;
}


// ---------------------------------------------------------------------------
//	 LOffscreenBufferPane(SPaneInfo&)								[public]
// ---------------------------------------------------------------------------

LOffscreenBufferPane::LOffscreenBufferPane(
	const SPaneInfo	&inPaneInfo)
		: LPane(inPaneInfo)
{
	mGWorld = nil;
}


// ---------------------------------------------------------------------------
//	 LOffscreenBufferPane(LStream*)			Stream Constructor	  [public]
// ---------------------------------------------------------------------------

LOffscreenBufferPane::LOffscreenBufferPane(
	LStream	*inStream)
		: LPane(inStream)
{
	mGWorld = nil;
}


// ---------------------------------------------------------------------------
//	 GetGWorld													  [public]
// ---------------------------------------------------------------------------

LGWorld*
LOffscreenBufferPane::GetGWorld()
{
	return mGWorld;
}


// ---------------------------------------------------------------------------
//	 SetGWorld													  [public]
// ---------------------------------------------------------------------------

void
LOffscreenBufferPane::SetGWorld(
	LGWorld*	inGWorld)
{
	if (mGWorld)
		delete mGWorld;
		
	mGWorld = inGWorld;
}


// ---------------------------------------------------------------------------
//	 DrawSelf													   [protected]
// ---------------------------------------------------------------------------

void
LOffscreenBufferPane::DrawSelf()
{		
	if (mGWorld != nil) {
		Rect	frame;
		CalcLocalFrameRect(frame);
		
		mGWorld->CopyImage(this->GetMacPort(), frame);
	}
	else {
		Rect	frame;
		CalcLocalFrameRect(frame);

		::PenNormal();
		::FillRect(&frame, &UQDGlobals::GetQDGlobals()->ltGray);
		::FrameRect(&frame);
	}
}
	
