// =================================================================================
//	C256Document.h					1997 eli curtz. All rights reserved.
// =================================================================================

#pragma once

#include <LSingleDoc.h>
#include <LListener.h>

#include "gorStuff.h"
#include "gorStructs.h"

class C256View;
class LStdButton;

class C256Document : public LSingleDoc, public LListener {
public:
						C256Document( LCommander *inSuper, FSSpec *inFileSpec );

	virtual Boolean		IsModified();
	
	virtual void		DoAESave( FSSpec &inFileSpec, OSType inFileType );
	virtual void		DoSave();
	virtual void		DoRevert();
	virtual void		DoPrint();

	virtual void		ListenToMessage(MessageT inMessage, void *ioParam);

protected:
	C256View *			m256View;
	LStdButton *		mNextButton;
	LStdButton *		mPrevButton;
	
	collection_header 	mCollectionHeader;
	Int32				mHeaderOffset;
	UInt16				mCurrentBitmap;
	CTabHandle			mColorTable;

	void				NameNewDoc();
	void				OpenFile( FSSpec &inFileSpec );
	void				SetPrintFrameSize(void);

	void				GoToBitmap(UInt16 inBitmapIndex);

private:
	LFileStream *		mFileStream; // screw casting mFile all the time
};