// ===========================================================================
//	C256View.cp				   1993-1997 eli curtz. All rights reserved.
// ===========================================================================
//

#ifdef PowerPlant_PCH
#include PowerPlant_PCH
#endif

#include <LPicture.h>
#include <LStream.h>
#include <UDrawingState.h>

#include <UGWorld.h>

#include "C256View.h"

// ---------------------------------------------------------------------------
//	 C256View						Default Constructor		  [public]
// ---------------------------------------------------------------------------

C256View::C256View()
{
	mGWorld = nil;
}


// ---------------------------------------------------------------------------
//	 C256View(LStream*)			Stream Constructor	  [public]
// ---------------------------------------------------------------------------

C256View::C256View(
	LStream	*inStream)
		: LView(inStream)
{
	mGWorld = nil;
}


// ---------------------------------------------------------------------------
//	 GetGWorld													  [public]
// ---------------------------------------------------------------------------

LGWorld*
C256View::GetGWorld()
{
	return mGWorld;
}


// ---------------------------------------------------------------------------
//	 SetGWorld													  [public]
// ---------------------------------------------------------------------------

void
C256View::SetGWorld(
	LGWorld*	inGWorld)
{
	if (mGWorld)
		delete mGWorld;
		
	mGWorld = inGWorld;
	Rect gWorldBounds;
	mGWorld->GetBounds(gWorldBounds);
	ResizeImageTo((gWorldBounds.right - gWorldBounds.left), (gWorldBounds.bottom - gWorldBounds.top), false);

	Refresh();
}


// ---------------------------------------------------------------------------
//	 DrawSelf													   [protected]
// ---------------------------------------------------------------------------

void
C256View::DrawSelf()
{		
	if (mGWorld != nil) {
		Rect	frame;
		GetRevealedRect(frame);
		PortToLocalPoint(topLeft(frame));
		PortToLocalPoint(botRight(frame));
		
		Rect gWorldFrame;
		mGWorld->GetBounds(gWorldFrame);
		
		::SectRect(&frame, &gWorldFrame, &frame);
		
		// LGWorld is missing this so we do it ourselves
		// mGWorld->CopyImage(this->GetMacPort(), frame);
		
		::CopyBits(&((GrafPtr) mGWorld->GetMacGWorld())->portBits,
					&(this->GetMacPort())->portBits,
					&frame, &frame, srcCopy, nil);
	}
	else {
		Rect	frame;
		GetRevealedRect(frame);

		::PenNormal();
		::FillRect(&frame, &UQDGlobals::GetQDGlobals()->ltGray);
		::FrameRect(&frame);
	}
}
	
