#ifndef __COLLECTION_REFERENCES_H__
#define __COLLECTION_REFERENCES_H__

/*
COLLECTION_REFERENCES.H
Saturday September 7, 1996 12:33 PM
*/

#include "definitions.h"
//#include "bitmaps.h"
#include "shape_file.h"

/* ---------- constants */

enum
{
	COLLECTION_REFERENCE_GROUP_TAG= 0x636f7265, // 'core' (looks like text)
	COLLECTION_REFERENCE_VERSION_NUMBER= 1,
	
	MAXIMUM_COLLECTION_REFERENCES_PER_MAP= 128,
	
	MAXIMUM_PERMUTATIONS_PER_COLLECTION_REFERENCE= 5
};

/* ---------- collection references */

#define SIZEOF_STRUCT_COLLECTION_REFERENCE 384
struct collection_reference
{
	file_tag collection_tag;

	short number_of_permutations;
	short_fixed tint_fraction;

	struct rgb_color colors[MAXIMUM_PERMUTATIONS_PER_COLLECTION_REFERENCE][MAXIMUM_HUE_CHANGES_PER_COLLECTION];

	struct rgb_color tint_color;

	short unused[18];

	// computed when postprocessing this definition
	
	short collection_index;
	short color_table_indexes[MAXIMUM_PERMUTATIONS_PER_COLLECTION_REFERENCE];
};

/* ---------- globals */

//extern struct definition_globals collection_references;

/* ---------- prototypes/COLLECTION_REFERENCES.C */

#define initialize_collection_references() \
	initialize_definitions(&collection_references)
#define initialize_collection_references_for_new_map() \
	initialize_definitions_for_new_map(&collection_references)
#define dispose_collection_references_from_old_map() \
	dispose_definitions_from_old_map(&collection_references)
#define collection_reference_tag_to_collection_reference_index(subgroup) \
	definition_tag_to_index(&collection_references, (subgroup))

/*
struct collection_reference *get_default_collection_reference(void);

int custom_collection_reference(file_tag base_unit_tag, struct rgb_color *primary_color, struct rgb_color *secondary_color);
int get_collection_reference_permutation(int collection_reference_index, int color_table_index);

// tag_header.user_data for collection references is collection_reference.collection_tag
unsigned long get_collection_reference_tag_header_user_data(struct collection_reference *collection_reference);

void set_global_tint_color(struct rgb_color *tint_color, short_fixed tint_fraction);

#ifdef DEBUG
#define get_collection_reference(type) ((struct collection_reference *)get_definition(&collection_references, (type)))
#else
#define get_collection_reference(type) (((struct collection_reference *)collection_references.definitions)+(type))
#endif
*/

#endif // __COLLECTION_REFERENCES_H__
