#ifndef __PROJECTILE_GROUP_DEFINITIONS_H__
#define __PROJECTILE_GROUP_DEFINITIONS_H__

/*
PROJECTILE_GROUP_DEFINITIONS.H
Thursday August 8, 1996 2:11 PM

Thursday August 8, 1996 2:11 PM
	you thought you'd take me by surprise, but now i'm here burning down your house.
*/

//#include "objects.h"
#include "definitions.h"
//#include "damage.h"

/* ---------- constants */

enum
{
	PROJECTILE_GROUP_DEFINITION_GROUP_TAG= 0x70726772, // 'prgr' (looks like text)
	PROJECTILE_GROUP_DEFINITION_VERSION_NUMBER= 1,

	MAXIMUM_PROJECTILE_GROUP_DEFINITIONS_PER_MAP= 80,

	MAXIMUM_NUMBER_OF_PARTS_PER_PROJECTILE_GROUP= 15
};

/* ---------- projectile group part */

enum // projectile group part definition flags
{
	_projectile_group_part_is_central_bit, // this part is a 1:1 replacement for the original object
	_projectile_group_part_is_on_ground_bit, // this part always begins on the ground, but still chooses a random radius
	
	NUMBER_OF_PROJECTILE_GROUP_PART_DEFINITION_FLAGS,

	_projectile_group_part_is_central_flag= FLAG(_projectile_group_part_is_central_bit),
	_projectile_group_part_is_on_ground_flag= FLAG(_projectile_group_part_is_on_ground_bit)
};

#define SIZEOF_STRUCT_PROJECTILE_GROUP_PART_DEFINITION 32
struct projectile_group_part_definition
{
	file_tag projectile_tag;

	unsigned long flags;
		
	short count_lower_bound, count_delta;
	short_fixed position_lower_bound, position_delta;

	short obsolete[2];
	
	fixed_fraction appearing_fraction; // chance that this part will actually be created
	
	short unused[4];
	
	short projectile_type;
};

/* ---------- projectile group */

enum // projectile group definition flags
{
	NUMBER_OF_PROJECTILE_GROUP_DEFINITION_FLAGS
};

#define SIZEOF_STRUCT_PROJECTILE_GROUP_DEFINITION 512
struct projectile_group_definition
{
	unsigned long flags;
	
	short number_of_parts;
	
	word pad;
	file_tag mesh_effect_tag;
	file_tag sound_tag;
	file_tag local_projectile_group_tag;

	short unused[3];
	
	short local_projectile_group_type;
	short mesh_effect_type;
	short sound_index;
	
	struct projectile_group_part_definition parts[MAXIMUM_NUMBER_OF_PARTS_PER_PROJECTILE_GROUP];
};

/* ---------- private prototypes */

/*
static boolean postprocess_projectile_group_definition(struct definition_globals *definitions,
	struct tag_header *header, struct projectile_group_definition *definition);

extern struct definition_globals projectile_group_definitions;
*/

/* ---------- macros */

/*
#define initialize_projectile_group_definitions() \
	initialize_definitions(&projectile_group_definitions)
#define initialize_projectile_group_definitions_for_new_map() \
	initialize_definitions_for_new_map(&projectile_group_definitions)
#define dispose_projectile_group_definitions_from_old_map() \
	dispose_definitions_from_old_map(&projectile_group_definitions)
#define projectile_group_definition_tag_to_projectile_group_type(subgroup) \
	definition_tag_to_index(&projectile_group_definitions, (subgroup))

struct projectile_group_definition *get_default_projectile_group_definition(void);
struct projectile_group_part_definition *get_default_projectile_group_part_definition(void);

// tag_header.user_data for projectile groups is undefined
unsigned long get_projectile_group_definition_tag_header_user_data(struct projectile_group_definition *projectile_group_definition);
*/

/* ---------- private code */

/*
#ifdef DEBUG
#define get_projectile_group_definition(type) ((struct projectile_group_definition *)get_definition(&projectile_group_definitions, (type)))
struct projectile_group_part_definition *get_projectile_group_part_definition(int type, struct projectile_group_definition *projectile_group, int part_index);
#else
#define get_projectile_group_definition(type) (((struct projectile_group_definition *)projectile_group_definitions.definitions)+(type))
#define get_projectile_group_part_definition(type, projectile_group_definition, part_index) ((projectile_group_definition)->parts + (part_index))
#endif
*/

#endif // __PROJECTILE_GROUP_DEFINITIONS_H__