/*------------------------------------------------------------------------------
----------
	bina.h
	Steve Ramsey		11/5/97

	These tags appear to mirror the DITL resources in the Myth app
resource fork. I
	suspect that Resorcerer was used to prototype the dialogs, and then
the DITLs and
	DLOGs were converted to this generic format for use on both platforms.

	Apparently, things like radio button behavior and list contents are
not coded into
	these tags. That information appears to be hard-coded in the app.

	Rect2D is merely an alias for a Mac-style Rect struct. The four
shorts within are
	top, left, bottom, right, in that order.
*/

//	There are more of these - I got bored of classifying them
#define kStaticTextItem		'stat'
#define kEditTextItem		'edit'
#define kPasswordTextItem	'pass'

#define kPushButtonItem		'butt'
#define kRadioButtonItem	'radi'
#define kCheckButtonItem	'chek'
#define kIconPopupMenuItem	'ipop'

#define kBannerItem			'bann'
#define kChatDisplayItem	'chat'
#define kListItem			'slst'
#define kPlayerListItem		'plli'
#define kReportItem			'repo'		//	End of level report
#define kPictureItem		'bitm'
#define kColorSelectItem	'colr'

#define kChartTitleItem		'ched'		//	End of netgame chart;
#define kChartGraphicItem	'cgrf'		//	contents vary depending on current selection
#define kChartTextItem		'cstt'

typedef struct bina_Struct
{
	UInt16			u1;
	UInt16			itemCount;
	Rect2D			dialogRect;
//	ItemEntry		itemList[];			// This repeats itemCount times
//	CString			itemText[];			// This repeats itemCount times
} amso_Struct;

typedef struct ItemEntry
{
	FourCharCode	itemType;
	UInt32			itemNumber;
	SInt32			u1;					// -1 is typical
	SInt32			flags;
	Rect2D			itemRect;
} ItemEntry;