// gorStructs.h
// Myth header structures as described by Ryan 10/7/97
// And reverse engineered by eli at later dates
#pragma once

struct gor_Header {
	UInt16			version;
	UInt16			dataVersion;
	char			name[32];
	UInt32			checksum;
	Int32			tagHeaderOffset;
	UInt16			headerCount;
	UInt16			headerSize;			// 64
	UInt16			flags;
	UInt16			padding;
	UInt32			modTime;
	UInt16			unused1[35];
	UInt16			unused2;
}; typedef struct gor_Header gor_Header;


struct dir_Header {
	UInt32			userData;
	char			name[32];
	FourCharCode	group;
	FourCharCode	subGroup;
	Int32			dataOffset;
	UInt32			dataSize;
	UInt32			version;
	UInt16			tagVersion;
	UInt16			flags;
	FourCharCode	fileTag;			// 'mth2'
}; typedef struct dir_Header dir_Header;

struct myth2dir_Header {
  	Int16	mIdentifierM2;	// Runtime
  	Byte	mFlagsM2;		// Always zero?  (Manus Celer Dei)
  	Byte	mTypeM2;		// Runtime
  	char	mName[32];
  	Int32	mTagGroup;
  	Int32	mTagID;
  	Int32	mTagOffset;
  	Int32	mTagSize;
  	Int32	mUserData;
  	Int16	mVersionM2;
  	Byte	mFoundationM2;	// Where it goes when building monolithic tags
		// Foundation types
		//  foundation_SmallInstall		= 0,
		//  foundation_MediumInstall	= 1,
		//  fountation_LargeInstall		= 2,
		//  foundation_SmallInterface	= 3,
		//  foundation_LargeInterface	= 4
  	Byte	mOwnerIndexM2;	// Runtime, set to FF
  	Int32	mMythCode;		// 'mth2'
}; typedef struct myth2dir_Header myth2dir_Header;
   


struct bitmapData_Header { // * Size = 48
	UInt16			width;
	UInt16			height;
	Int16			rowBytes;			// -1 for encoded sprite
	UInt16			unknown;
	UInt16			bitDepth;
	UInt16 widthShift;     				// log(2) width
	UInt16 heightShift;    				// log(2) height
	UInt16 u2 [7];
	UInt16 u3;             				// these two match widthShift and heightShift
	UInt16 u4;             				//      for unencoded sprites
	UInt16 u5;             				// these two match width and height
	UInt16 u6;             				//      for unencoded sprites
	UInt16 u7 [6];
}; typedef struct bitmapData_Header bitmapData_Header;

// use geometry_definitions.h
/*
struct geom_Header {
	Int32			u1;
	FourCharCode	coreId;
	Int16			refCount;
	Int16			vertexCount;
	Int16			triangleCount;
	Int16			unknownCount;
	Int32			u3;	
	Int32			u4;	
	Int32			u5;	
	Int32			refOffset;	
	Int32			refSize;		// refCount * 64
	Int32			u6;	
	Int32			vertexOffset;	
	Int32			vertexSize;		// vertexCount * 6
	Int32			u7;	
	Int32			triangleOffset;	
	Int32			triangleSize;	// triangleCount * 64
	Int32			u8;	
	Int32			uOffset;	
	Int32			uSize;			// unknownCount * 2
	Int32			u9;	
	Int32			headerSize;		// 96
	Int32			dataSize;
	Int32			junk[3];	
}; typedef struct geom_Header geom_Header;


struct geom_Ref {
	char			name[32];
	Int16			idNumber;
	Int16			flags;			// ?
	Int32			textureIndex;	// only if flags == 1
	Int8			unknown[24];
}; typedef struct geom_Ref geom_Ref;

struct geom_Vertex {
	Int16			x;
	Int16			y;
	Int16			z;
}; typedef struct geom_Vertex geom_Vertex;


typedef struct geom_TriangleVertex {
    UInt16			textureU;
    UInt16			textureV;
    SInt16			vertexIndex;
    SInt16			u1;
} geom_TriangleVertex;

typedef struct geom_Triangle {
    SInt16				u1[6];
    SInt16				minX;
    SInt16				minY;
    SInt16				minZ;
    SInt16				maxX;
    SInt16				maxY;
    SInt16				maxZ;
    SInt16				maybeTransparency;
    SInt16				refIDNumber;
    geom_TriangleVertex	vertices[3];
    SInt16				u5[3];  // always -1 ?
    SInt16				u6[3];
} geom_Triangle;
*/

struct mesh_Header {
	FourCharCode	textureRef;
	FourCharCode	mediaRef;
	UInt16			width;				// 16 point sections
	UInt16			height;				// 16 point sections
	Int32			meshOffset;
	Int32			meshSize;
	Int32			u2;
	Int32			headerSize;			// 1024 always?
	Int32			dataSize;
	Int32			u3;
	Int32			objectTypeCount;
	Int32			objectTypeOffset;
	Int32			objectTypeSize;		// objectTypeCount * 32
	Int32			u4;
	Int32			objectInstanceCount;
	Int32			objectInstanceOffset;
	Int32			objectInstanceSize;	// objectInstanceCount * 64
	Int32			u5;
	FourCharCode	u6;
	FourCharCode	u7;
	Int32			u8[10];
	Int16			u9;	
	Int16			u10;	
	Int16			u11;	
	Int16			u12;	
	FourCharCode	u13;
	Int32			commandCount;
	Int32			commandOffset;
	Int32			commandSize;		// includes arguments
	FourCharCode	descriptionRef;
	FourCharCode	postgameRef;
	FourCharCode	pregameRef;
	FourCharCode	overheadmapRef;
	FourCharCode	Ref1;
	FourCharCode	Ref2;
	FourCharCode	Ref3;
	FourCharCode	Ref4;
	FourCharCode	Ref5;
	FourCharCode	Ref6;
	FourCharCode	Ref7;
	FourCharCode	Ref8;
	FourCharCode	Ref9;
	Int32			mediaRegionOffset;
	Int32			mediaRegionSize;
	Int32			u14;
	Int32			mediaPolygonsOffset;
	Int32			mediaPolygonsSize;
	
	// Much more left out for now 1024 bytes total
}; typedef struct meshData_Header meshData_Header;

struct mesh_ObjectType {
	Int16			typeFlag;		// 0 = team?, 1 = 'scen', 3 = 'unit', 5 = 'amso', 6 = 'mode', 9 = 'prgr', 10 = 'lpgr'
	Int16			u1;
	FourCharCode	subGroupTag;
	Int16			teamGroupNumber;
	Int16			u3;
	Int32			u4[4];
	Int16			instanceCount;	// number on map
	Int16			typeIndex;		// among types with same typeFlag
}; typedef struct mesh_ObjectType mesh_ObjectType;

struct mesh_ObjectInstance {
	Int32			visibilityFlags;	// 1 == initially hidden
	Int16			typeFlag;
	Int16			typeIndex;		// among ALL objectTypes
	Int16			objectID;
	Int16			u2;
	Int32			locationX;
	Int32			locationY;
	Int32			locationZ;
	Int32			u3;
	Int32			u4;
	Int16			facingAngle;
	Int16			u5;
	Int16			u6[14];			// multiple flags, etc.
}; typedef struct mesh_ObjectInstance mesh_ObjectInstance;

struct mesh_Command {
	Int16			commandLabel;
	Int16			u1;
	FourCharCode	commandType;	// As described in 'temp' file
	Int32			u2[3];
	Int16			argumentCount;
	Int16			argDataSize;
	Int32			argDataOffset;
	Int32			u3[9];
}; typedef struct mesh_Command mesh_Command;

struct mesh_CmdArgument {
	Int16			dataUnitType;
	Int16			dataUnitCount;
	FourCharCode    argumentType;	// As described in 'temp' file
	Byte			data[];			// dataUnitSize * dataUnitCount, pad to Int32
}; typedef struct mesh_CmdArgument mesh_CmdArgument;
