#ifdef OBSOLETE

#ifndef __MODEL_FILE_H__
#define __MODEL_FILE_H__

/*
 * MODEL_FILE.H
 */
 
#include "cseries.h"
#include "world.h"
#include "render.h"
#include "tag_files.h"
#include "mesh.h"
#include "geometry_file.h"

/* ---------- constants */

enum
{
	MODEL_GROUP_TAG= 0x6d6f6465,	// 'mode'
	MODEL_VERSION_NUMBER= 4,
	MODEL_FILE_TYPE= 0x4d4f4445,	// 'MODE'

	MAXIMUM_CELLS_PER_MODEL= 128
};

/* ---------- macros */

/* ---------- structures */
#define SIZEOF_STRUCT_MODEL_PERMUTATION_DATA 64
struct model_permutation_data {
	short collection_reference_permutation;	

	byte permutations[MAXIMUM_MATERIALS_PER_GEOMETRY]; // permutations for the given material

	short unused[13];
	short collection_index; // loaded at run time
	short color_table_index; // at run time...
};

enum {
	_vertex_deforms_mesh_bit,
	_vertex_is_media_bit,
	_vertex_wobbles_when_media_bit,
	NUMBER_OF_GEOMETRY_VERTEX_BITS,
	
	_vertex_deforms_mesh_flag= FLAG(_vertex_deforms_mesh_bit),
	_vertex_is_media_flag= FLAG(_vertex_is_media_bit),
	_vertex_wobbles_when_media_flag= FLAG(_vertex_wobbles_when_media_bit)
};

#define SIZEOF_STRUCT_GEOMETRY_INDEX_DATA (4)
struct geometry_vertex_data {
	long flags;
};

enum {
	_model_mesh_cell_replaces_mesh_bit, // mesh cell under this does not render
	_mesh_cell_is_impassable_walking_bit,
	_mesh_cell_is_impassable_flying_bit,
	_mesh_cell_overlapped_by_model_bit,
	NUMBER_OF_MODEL_MESH_CELL_BITS,
	
	_model_mesh_cell_replaces_mesh_flag= FLAG(_model_mesh_cell_replaces_mesh_bit),
	_mesh_cell_is_impassable_walking_flag= FLAG(_mesh_cell_is_impassable_walking_bit),
	_mesh_cell_is_impassable_flying_flag= FLAG(_mesh_cell_is_impassable_flying_bit),
	_mesh_cell_overlapped_by_model_flag= FLAG(_mesh_cell_overlapped_by_model_bit)
};

#define SIZEOF_STRUCT_MODEL_MESH_DATA (8) 
struct model_mesh_cell_data {
	short x, y;
	word flags;
	word unused;
};

#define SIZEOF_STRUCT_MODEL_DEFINITION 64
struct model_definition
{
	unsigned long flags;
	
	file_tag geometry_tag;
	short geometry_index;

	// counts	
	short model_geometry_vertex_count;
	short model_permutation_count;
	short model_cell_count;

	// array of geometry_vertex flags...
	int model_geometry_vertex_offset, model_geometry_vertex_size;
	struct geometry_vertex_data *vertex_flags;

	// array of model_permutations
	int model_permutations_offset, model_permutations_size;
	struct model_permutation_data *model_permutations;

	// array of model_mesh_cell_data
	int model_cell_offset, model_cell_size;
	struct model_mesh_cell_data *model_cells;

	// conglomerate data pointer..
	long data_offset, data_size;
	void *data; // memory-based
};
#endif

#endif