// ===========================================================================
// CGWorldView.h
// ===========================================================================
/* This class implements a view that mirrors the contents of a GWorld. */
	
	
#pragma once
#include <LView.h>
#include <UGWorld.h>

const PaneIDT kGWPaneID = 'Gwld';	// PaneID in Example Window
const PaneIDT kGWorldWindowTimed = 20023;
const PaneIDT kGWorldWindowListener = 20024;

class CGWorldView : public LView {
	public:
		CGWorldView();
		CGWorldView(LStream *inStream);
		~CGWorldView(void);
		void				SetMyGWorld(LGWorld *inGW);
		
	protected:
		void				DrawSelf();
		
	protected:
		LGWorld				*mGWorld;
};

class CGWorldViewTimed : public CGWorldView, public LPeriodical {
	public:
		enum { class_ID = 'CGwT' };
		
		CGWorldViewTimed();
		CGWorldViewTimed(LStream *inStream);
		~CGWorldViewTimed(void);
		void				SetMyGWorld(LGWorld *inGW);
		void				SpendTime(const EventRecord	&inMacEvent);
		void				SetDrawInterval(short inSeconds) {mDrawInterval = inSeconds*60;};
		
	protected:
		Uint32				mLastDraw;
		Uint32				mDrawInterval; // in Ticks
};


const MessageT	msg_JustChanged	= 'JtCh';	// this is the Message to send in order to get the Pane to draw a new copy of the GWorld

class CGWorldViewListener : public CGWorldView, public LListener {
	public:
		enum { class_ID = 'CGwL' };
		
		CGWorldViewListener();
		CGWorldViewListener(LStream *inStream);
		~CGWorldViewListener(void);
		void				ListenToMessage(
								MessageT		inMessage,
								void			*ioParam);
};
