// =================================================================================
//	CBlendTable.cp				 1998 Hans Hvidsten Birkeland. All rights reserved.
// =================================================================================

#include "CBlendTable.h"
#include "CopyBytes.h"


// =================================================================================
//	 CBlendTable															[public]
// =================================================================================
					
CBlendTable::CBlendTable( void )
{
	for ( int i = 0; i < 0x10000; i++ )
		mTable[i] = 0;
}


// =================================================================================
//	 ReadData																[public]
// =================================================================================
// inBlendTableData is a buffer containing the gotKnowsWhat entry data as they are
// stored in the .gor files and plugin files.

void
CBlendTable::ReadData( Byte *inBlendTableData )
{
	inBlendTableData += ::CopyBytes( inBlendTableData, mTable, 0x10000 );
}
	

// =================================================================================
//	 WriteData														 [const, public]
// =================================================================================
// outBlendTableData is filled with the blend table data as they are stored on
// file
					
void
CBlendTable::WriteData( Byte *outBlendTableData ) const
{
	outBlendTableData += ::CopyBytes( mTable, outBlendTableData, 0x10000 );
}


// =================================================================================
//	 GetSize														 [const, public]
// =================================================================================
// Return the blend table size in bytes

Int32
CBlendTable::GetSize( void ) const
{
	return 0x10000;
}


