// =================================================================================
//	CBlendTable.h				 1998 Hans Hvidsten Birkeland. All rights reserved.
// =================================================================================

#pragma once


#include "CTagElement.h"


// =================================================================================
//	CBlendTable														   [65536 bytes]
// =================================================================================
// After the shadow maps come the blending tables (used only in texture maps ?)

class CBlendTable : public CTagElement {
public:
	enum			{	// Constant element size
						kElementSize		= 0x10000L
					};
					
					
					// Default constructor
					
					CBlendTable();
					
					// inBlendTableData is a buffer containing the
					// blending table in raw format
					
	void			ReadData( Byte *inBlendTableData );
	
					// outBlendTableData is filled with the
					// CBlendTable in raw format
					
	void			WriteData( Byte *outBlendTableData ) const;
	
					// Return the blend table size on file
					
	Int32			GetSize() const;

private:
					// Defensive programming
					CBlendTable( const CBlendTable &inTable );
	CBlendTable		&operator=( const CBlendTable &inTable );
	
	Byte mTable[0x10000L];
};


