// =================================================================================
//	CRemapTable.cp				 1998 Hans Hvidsten Birkeland. All rights reserved.
// =================================================================================

#include "CRemapTable.h"
#include "CopyBytes.h"


// =================================================================================
//	 CRemapTable															[public]
// =================================================================================
					
CRemapTable::CRemapTable( void )
{
	for ( int i = 0; i < 256; i++ )
		mTable[i] = 0;
}


// =================================================================================
//	 ReadData																[public]
// =================================================================================
// inRemapTableData is a buffer containing the color remapping table as it is
// stored in the .gor files and plugin files.

void
CRemapTable::ReadData( Byte *inRemapTableData )
{
	inRemapTableData += ::CopyBytes( inRemapTableData, mTable, 256 );
}
	

// =================================================================================
//	 WriteData														 [const, public]
// =================================================================================
// outRemapTableData is filled with the color remapping table as it is stored on
// file
					
void
CRemapTable::WriteData( Byte *outRemapTableData ) const
{
	outRemapTableData += ::CopyBytes( mTable, outRemapTableData, 256 );
}


// =================================================================================
//	 GetSize														 [const, public]
// =================================================================================
// Return the remap table size in bytes

Int32
CRemapTable::GetSize( void ) const
{
	return 256;
}


