// =================================================================================
//	CRemapTable.h				 1998 Hans Hvidsten Birkeland. All rights reserved.
// =================================================================================

#pragma once


#include "CTagElement.h"


// =================================================================================
//	CRemapTable															 [256 bytes]
// =================================================================================
// After the blending tables come the color remapping tables (used
// only in texture maps ?)

class CRemapTable : public CTagElement {
public:
	enum			{	// Constant element size
						kElementSize		= 256
					};
	
	
					// Default constructor
	
					CRemapTable();
					
					// inRemapTableData is a buffer containing the
					// CRemapTable in raw format
					
	void			ReadData( Byte *in6RemapTableData );
	
					// outRemapTableData is filled with the
					// CRemapTable in raw format
					
	void			WriteData( Byte *outRemapTableData ) const;
	
					// Return the remap table size on file
					
	Int32			GetSize() const;

private:
					// Defensive programming
					CRemapTable( const CRemapTable &inTable );
	CRemapTable		&operator=( const CRemapTable &inTable );
	
	Byte mTable[256];
};


