// =================================================================================
//	CSequenceReference.h		 1998 Hans Hvidsten Birkeland. All rights reserved.
// =================================================================================

#pragma once

#include "CTagElement.h"
class CSequenceData;


// =================================================================================
//	CSequenceReference													 [128 bytes]
// =================================================================================
// Following the bitmapInstance entries are the sequences. These entries contain
// information regarding how the bitmaps are grouped together.

class CSequenceReference : public CTagElement {
friend				class CSequence;

protected:
					// Default constructor and destructor
					
					CSequenceReference();
	
					// inSequenceData is a buffer containing the sequence
					// data as they are stored in the .gor files and plugin
					// files.
					
	void			ReadData( const Byte *inSequenceData );
	
					// outSequenceData is filled with the sequence data
					// as they are stored on file
					
	void			WriteData( Byte *outSequenceData ) const;
	
					// Return the size of the sequence reference on file
					
	Int32			GetSize() const;
	
				// Accessors
	
	const char		*GetName() const;
	void			SetName( const char *inName );
	void			SetName( ConstStr255Param inName );
	
	Int32			GetDataOffset() const;
	void			SetDataOffset( Int32 inOffset );
	
	Int32			GetDataSize() const;
	void			SetDataSize( Int32 inSize );
	
	void			UpdateFromData( const CSequenceData *inData );
	
private:
					// Defensive programming
					CSequenceReference( const CSequenceReference & );
	CSequenceReference	&operator=( const CSequenceReference & );
	
	char mName[64];
	Int32 mDataOffset;
	Int32 mDataSize;
//	void *mData;			// Mem based, zero out

//	Byte mUnused[52];		// Unused, zero out
};


