// =================================================================================
//	CTagElementArray.cp			 1998 Hans Hvidsten Birkeland. All rights reserved.
// =================================================================================
// A tiny tweak to LArray to make it automatically delete its elements


#include "CTagElementArray.h"
#include "CTagElement.h"


// =================================================================================
//	 CTagElementArray														[public]
// =================================================================================

CTagElementArray::CTagElementArray( void )
: LArray( sizeof( void * ) )
{
}


// =================================================================================
//	 ~CTagElementArray														[public]
// =================================================================================

CTagElementArray::~CTagElementArray( void )
{
	if (mLockCount > 0) {
		SignalPStr_("\pDeleting a locked Array");
	}
	
	if ( mItemSize != sizeof(void *) )
		SignalPStr_("\pCTagElementArray used with bad item size");
	
	// Delete elements
	LArrayIterator theIterator( *this );
	CTagElement *theElement;
	
	while ( theIterator.Next( &theElement ) )
		delete theElement;
	
}

