// =================================================================================
//	CTag.h						 1998 Hans Hvidsten Birkeland. All rights reserved.
// =================================================================================

#pragma once


#include <LListener.h>
#include <LBroadcaster.h>
class CTagHeader;


// =================================================================================
//	 CTag
// =================================================================================

class CTag : public LListener,
			 public LBroadcaster {
public:
						
	enum 						{	// Standard tag errors
									err_WrongTagFormat	= 'TAGf',
									err_HasNoTagHeader	= 'TAGh'
								};
	
								// Default constructor and destructor
						
								CTag();
	virtual						~CTag();
	
								// The tag header
	
	virtual void				ReadTagHeader( LStream &inStream );
	virtual long				WriteTagHeader( LStream &outStream );
	virtual long				GetTagHeaderSize() const;
	
	virtual const CTagHeader	*GetTagHeader() const;
	virtual CTagHeader			*GetTagHeader();
	
	virtual OSType				GetTagGroup() const;
	
								// The tag file
	
	virtual OSType				GetFileCreator() const;
	virtual OSType				GetFileType() const;
	
								// The tag itself
	
	virtual void				ReadStream( LStream &inStream, Int32 inOffset ) = 0;
	virtual void				WriteStream( LStream &outStream, Int32 inOffset ) = 0;
	
	virtual Int32				GetSize() const = 0;

	virtual Boolean				IsDirty() const;

protected:
								// Defensive programming
								CTag( const CTag & );
	CTag						&operator=( const CTag & );
	
	virtual void				UpdateTagHeader();
	virtual void				SetDirty( Boolean inDirty = true );
	
	CTagHeader		*mTagHeader;
	Boolean			mDirty;
};
