// =================================================================================
//	CTagHeader.cp				 1998 Hans Hvidsten Birkeland. All rights reserved.
// =================================================================================
// File created Jun 17, 1998

#pragma once

class CTagHeader {
public:
	enum				{	// Exceptions
							err_BadMythVersion			= 'myth',
							
							// Foundation types
							foundation_SmallInstall		= 0,
							foundation_MediumInstall	= 1,
							foundation_LargeInstall		= 2,
							foundation_SmallInterface	= 3,
							foundation_LargeInterface	= 4
						};
	
						CTagHeader();
	
	Int32				ReadStream( LStream &inStream );
	Int32				WriteStream( LStream &outStream );
	
	Boolean				IsValidTag( Int32 inTagGroup = 0 ) const;
	Int32				GetSize() const;
	
	void				SetName( const char *inName );
	void				SetName( const StringPtr inName );
	const char			*GetName() const;
	
	Int32				GetMythCode() const;
	void				SetMythCode( Int32 inMythCode );
	
	void				SetTagGroup( Int32 inTagGroup );
	Int32				GetTagGroup() const;
	
	void				SetTagID( Int32 inTagID );
	Int32				GetTagID() const;
	
	void				SetTagOffset( Int32 inTagOffset );
	Int32				GetTagOffset() const;
	
	void				SetUserData( Int32 inUserData );
	Int32				GetUserData() const;
	
	void				SetTagSize( Int32 inLenght );
	Int32				GetTagSize() const;
	
protected:
	
	char	mName[32];
	Int32	mTagGroup;
	Int32	mTagID;
	Int32	mVersionM1;		// Myth I
	Int16	mTagVersionM1;	// Myth I
	Int16	mFlagsM1;		// Myth I
	Int32	mTagOffset;
	Int32	mTagSize;
	Int32	mUserData;
	Int32	mMythCode;
	
	// Myth II
//	Int16	mIdentifierM2;	// Runtime
//	Byte	mFlagsM2;		// Always zero?  (Manus Celer Dei)
//	Byte	mTypeM2;		// Runtime
	Int16	mVersionM2;
	Byte	mFoundationM2;	// Where it goes when building monolithic tags
//	Byte	mOwnerIndexM2;	// Runtime, set to FF
};