// =================================================================================
//	CgeomApp.h	 					1997 eli curtz. All rights reserved.
// =================================================================================

#pragma once

#include <LDocApplication.h>
#include <LPeriodical.h>
#include <LBroadcaster.h>
#include <LView.h>

class CgeomApp : public LDocApplication
{
public:
							CgeomApp();
	virtual 				~CgeomApp();
	
	virtual void			ShowAboutBox();

protected:
	virtual void			StartUp();
	virtual void			OpenDocument( FSSpec *inMacFSSpec );
	virtual LModelObject *	MakeNewDocument();
	virtual void			ChooseDocument();
	virtual void			PrintDocument( FSSpec *inMacFSSpec );
};

class CAboutIdler :	public LPeriodical,
					public LBroadcaster
{
public:
					CAboutIdler( MessageT inMessage, UInt32 inFrequency );
	virtual			~CAboutIdler();
	
	virtual	void	SpendTime( const EventRecord& inMacEvent );
	
protected:
	MessageT 	mMessage;
	
	UInt32		mFrequency;
	UInt32		mLastBroadcast;
};

class CCenteredView : public LView
{
public:
	enum { class_ID = 'erd' };
	
							CCenteredView();
							CCenteredView( LStream *inStream );
	virtual					~CCenteredView();
	
	virtual void		AdaptToSuperFrameSize(
								SInt32		inSurrWidthDelta,
								SInt32		inSurrHeightDelta,
								Boolean		inRefresh);
};