// =================================================================================
//	CgeomDocument.h					1997 eli curtz. All rights reserved.
// =================================================================================

#pragma once

#include <LSingleDoc.h>
#include <LListener.h>

#include "gorStuff.h"
#include "gorStructs.h"

#include "definitions.h"
#include "geometry_definitions.h"

class CgeomView;

class CgeomDocument : public LSingleDoc, public LListener {
public:
						CgeomDocument( LCommander *inSuper, FSSpec *inFileSpec );
						~CgeomDocument();

	virtual Boolean		IsModified();
	
	virtual void		DoAESave( FSSpec &inFileSpec, OSType inFileType );
	virtual void		DoSave();
	virtual void		DoRevert();
	virtual void		DoPrint();

	virtual void		DoExport();

	virtual void		ListenToMessage(MessageT inMessage, void *ioParam);

protected:
	CgeomView *			mGeomView;

	void				NameNewDoc();
	void				OpenFile( FSSpec &inFileSpec );
	void				SetPrintFrameSize(void);

private:
	LFileStream *		mFileStream; // screw casting mFile all the time
	
	geometry_definition	mGeometry;
	Int32				mHeaderOffset;

	LFileStream *		FindRelatedFile(FSSpec& inFileSpec, FourCharCode inGroup, FourCharCode inSubGroup );
	void				AddTexture(TQ3GeometryObject& ioObject, LFileStream* inFile, UInt16 inTextureIndex);

	LArray * 			mTextureGWorlds;
};