// =================================================================================
//	CgeomView.h						1997 eli curtz. All rights reserved.
// =================================================================================

#pragma once

#ifndef QD3DPick_h
#include <QD3DPick.h>
#endif

#include "CNew3DView.h"

const SInt16 kTransparencyMenuID = 1750;

enum
{
	kButtonTransparent = NUMBER_OF_3D_BUTTONS,
	kButtonNoCull,
	kButtonUnderMesh,
	kButtonReflective,
	kButtonClosestZ,
	kButtonDependencies,
	kButtonReplacesMesh,
	kButtonNoWalk,
	kButtonNoFly,
	kButtonOverlapped,
	kButtonDeformsMesh,
	kButtonMedia,
	kButtonWobbles,
	NUMBER_OF_GEOM_BUTTONS
};

enum
{
	kToolTransparent 	= kButtonTransparent,
	kToolNoCull			= kButtonNoCull,
	kToolUnderMesh 		= kButtonUnderMesh,
	kToolReflective 	= kButtonReflective,
	kToolClosestZ 		= kButtonClosestZ,
	kToolDependencies 	= kButtonDependencies,
	kToolReplacesMesh 	= kButtonReplacesMesh,
	kToolNoWalk 		= kButtonNoWalk,
	kToolNoFly 			= kButtonNoFly,
	kToolOverlapped 	= kButtonOverlapped,
	kToolDeformsMesh 	= kButtonDeformsMesh,
	kToolMedia 			= kButtonMedia,
	kToolWobbles 		= kButtonWobbles
};

enum
{
	kCamera_MoveForward	= 0,
	kCamera_MoveBack,
	kCamera_MoveLeft,
	kCamera_MoveRight,
	kCamera_PanLeft,
	kCamera_PanRight,
	kCamera_OrbitLeft,
	kCamera_OrbitRight,
	kCamera_OrbitUp,
	kCamera_OrbitDown,
	kCamera_ZoomIn,
	kCamera_ZoomOut,
	NUMBER_OF_CAMERA_KEYS
};

const PaneIDT kIDTransparent 	= 'ST00';
const PaneIDT kIDNoCull 		= 'ST01';
const PaneIDT kIDUnderMesh 		= 'ST02';
const PaneIDT kIDReflective 	= 'ST03';
const PaneIDT kIDClosestZ 		= 'ST04';
const PaneIDT kIDDependencies 	= 'ST05';
const PaneIDT kIDReplacesMesh 	= 'MT00';
const PaneIDT kIDNoWalk		 	= 'MT01';
const PaneIDT kIDNoFly			= 'MT02';
const PaneIDT kIDOverlapped 	= 'MT03';
const PaneIDT kIDDeformsMesh 	= 'VT00';
const PaneIDT kIDMedia		 	= 'VT01';
const PaneIDT kIDWobbles	 	= 'VT02';

const PaneIDT kIDCaption		= 'Info';

const MessageT kMsgTransparent 	= kIDTransparent;
const MessageT kMsgNoCull 		= kIDNoCull;
const MessageT kMsgUnderMesh 	= kIDUnderMesh;
const MessageT kMsgReflective 	= kIDReflective;
const MessageT kMsgClosestZ 	= kIDClosestZ;
const MessageT kMsgDependencies = kIDDependencies;
const MessageT kMsgReplacesMesh = kIDReplacesMesh;
const MessageT kMsgNoWalk		= kIDNoWalk;
const MessageT kMsgNoFly		= kIDNoFly;
const MessageT kMsgOverlapped 	= kIDOverlapped;
const MessageT kMsgDeformsMesh 	= kIDDeformsMesh;
const MessageT kMsgMedia		= kIDMedia;
const MessageT kMsgWobbles	 	= kIDWobbles;

#define IS_GEOM_TOOL(x)		( ((x) >= kToolTransparent) && ((x) <= kToolWobbles) )
#define IS_SURFACE_TOOL(x)	( ((x) >= kToolTransparent) && ((x) <= kToolDependencies) )
#define IS_MESH_TOOL(x)		( ((x) >= kToolReplacesMesh) && ((x) <= kToolOverlapped) )
#define IS_VERTEX_TOOL(x)	( ((x) >= kToolDeformsMesh) && ((x) <= kToolWobbles) )

#define _GEOMETRY_DEPENDENCY_FAKE_FLAG _geometry_surface_negative_flag

class C3dmfDocument;

class LCaption;

class CgeomView : public CNew3DView {
public:
	enum { class_ID = 'geom' };
	
						CgeomView();
						CgeomView(
								LStream				*inStream);

	virtual void		FinishCreateSelf();

	virtual void		ClickSelf(const SMouseDownEvent &inMouseDown);
	virtual Boolean		HandleKeyPress( const EventRecord &inKeyEvent );
	virtual void		ListenToMessage( MessageT inMessage, void* ioParam );
	
	void				SetDocument( C3dmfDocument* inDocument ) { mDocument = inDocument; };
	
	static UInt32		DataFlagFromTool( UInt32 inTool );

//	virtual Boolean		HandleKeyPress( const EventRecord &inKeyEvent );

protected:
	UInt16				mCameraKeys[NUMBER_OF_CAMERA_KEYS];
	
	TQ3PickObject		mVertexPicker;
	
	C3dmfDocument*		mDocument;
	
	LCaption*			mCaption;
	
	UInt32				mLastViewTool;
	UInt32				mLastEditTool;
	
	Boolean				mDisplayedMeshAlert;

	virtual TQ3Status	RenderSelf();
};
