/*  NAME:
        E3ViewerTools.h

    DESCRIPTION:
        Implementation of Quesa API calls.

    COPYRIGHT:
        Quesa Copyright  1999-2000, Quesa Developers.
        
        For the list of Quesa Developers, and contact details, see:
        
            Documentation/contributors.html

        For the current version of Quesa, see:

        	<http://www.quesa.org/>

		This library is free software; you can redistribute it and/or
		modify it under the terms of the GNU Lesser General Public
		License as published by the Free Software Foundation; either
		version 2 of the License, or (at your option) any later version.

		This library is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
		Lesser General Public License for more details.

		You should have received a copy of the GNU Lesser General Public
		License along with this library; if not, write to the Free Software
		Foundation Inc, 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
    ___________________________________________________________________________
*/
#ifndef E3VIEWERTOOLS_HDR
#define E3VIEWERTOOLS_HDR
//=============================================================================
//      Include files
//-----------------------------------------------------------------------------
#if 1
#include <QD3D.h>
#else
#include "Quesa.h"
#endif




//=============================================================================
//		C++ preamble
//-----------------------------------------------------------------------------
#ifdef __cplusplus
extern "C" {
#endif





//=============================================================================
//      Function prototypes
//-----------------------------------------------------------------------------
TQ3XFunctionPointer BaseToolMetaHandler		(TQ3XMethodType methodType);
TQ3XFunctionPointer CameraToolMetaHandler	(TQ3XMethodType methodType);
TQ3XFunctionPointer TruckToolMetaHandler	(TQ3XMethodType methodType);
TQ3XFunctionPointer OrbitToolMetaHandler	(TQ3XMethodType methodType);
TQ3XFunctionPointer ZoomToolMetaHandler		(TQ3XMethodType methodType);
TQ3XFunctionPointer DollyToolMetaHandler	(TQ3XMethodType methodType);
TQ3XFunctionPointer ResetToolMetaHandler	(TQ3XMethodType methodType);
TQ3XFunctionPointer OptionsToolMetaHandler	(TQ3XMethodType methodType);
TQ3XFunctionPointer AboutToolMetaHandler	(TQ3XMethodType methodType);





//=============================================================================
//		C++ postamble
//-----------------------------------------------------------------------------
#ifdef __cplusplus
}
#endif

#endif

