/*
Copyright  1997 Sailmaker Software Ltd. All rights reserved.
			<mailto:richardb@sailmaker.co.uk>
			<http://www.sailmaker.co.uk/>

File:		CDecimalCaption.cp
Author:		Richard Buckle
Purpose:	subclass of LCaption, for decimal numbers
Status:		Copyrighted freeware

See read me for instructions and conditions of use.

*/

#include "CDecimalCaption.h"

#pragma mark ----- Instance methods -----
// constructor
CDecimalCaption::CDecimalCaption( LStream *inStream )
	: LCaption( inStream ),
	CDecimalDescription( inStream ),
	mStripTrailingDecimal(false)
	{
	inStream->ReadData(&mStripTrailingDecimal, sizeof(Boolean));
	}
	
// destructor	
CDecimalCaption::~CDecimalCaption()
	{}

#pragma mark -
#pragma mark ----- Public accessors -----
// return the value as a double
double CDecimalCaption::GetDoubleValue()
	{
	Str255 theStr;
	GetDescriptor( theStr );
	return StrToDoubleValue( theStr );
	}
	
// set the value to the given double
void CDecimalCaption::SetDoubleValue( const double iValue )
	{
	Str255 theStr;
	DoubleValueToStr( theStr, iValue, mStripTrailingDecimal );
	SetDescriptor( theStr );
	}