/*
Copyright  1997 Sailmaker Software Ltd. All rights reserved.
			<mailto:richardb@sailmaker.co.uk>
			<http://www.sailmaker.co.uk/>

File:		CDecimalCaption.h
Author:		Richard Buckle
Purpose:	subclass of LCaption, for decimal numbers
Status:		Copyrighted freeware

See read me for instructions and conditions of use.

*/

#pragma once			/* Include this file only once */

#include <LCaption.h>
#include "CDecimalDescription.h"

class CDecimalCaption : public LCaption, 
					public CDecimalDescription 
	{
	public:
		enum { class_ID = 'Dcap' };
		
		// Instance methods
		CDecimalCaption( LStream *inStream );
		virtual ~CDecimalCaption();
		
		// Public accessors
		virtual double GetDoubleValue();
		virtual void SetDoubleValue( const double iValue );
	
	private:
		Boolean				mStripTrailingDecimal; // if true, then the trailing ".0" is stripped
													// if thethe value is integral
	};