/*
Copyright  1997 Sailmaker Software Ltd. All rights reserved.
			<mailto:richardb@sailmaker.co.uk>
			<http://www.sailmaker.co.uk/>

File:		CDecimalDescription.h
Author:		Richard Buckle
Purpose:	mixin class to manage formatted conversion to and from decimal numbers
Status:		Copyrighted freeware

See read me for instructions and conditions of use.

*/

#pragma once

class CDecimalDescription
	{
	public:
		// Instance methods
		CDecimalDescription( LStream *inStream );
		CDecimalDescription( const ResIDT	inFStrID );

		virtual ~CDecimalDescription();
		
		// Public Interface
			// return the value as a double
		virtual double	StrToDoubleValue( const Str255 iStr );
			// set the value to the given double
		virtual void	DoubleValueToStr( Str255 oStr, 
											const double inValue, 
											const Boolean inStripTrailingDecimal=false );
		// Utility functions for 68K
		static extended80 ToExtended80( const double inValue );
		static double ToDouble( const extended80 inValue );
		
	protected:
		// Implementation
			// init or re-init ourselves from a 'FMAT' or 'FStr' resource
		void InitDecimalDescription( const ResIDT iResID );
		
			// strip any trailing ".0" if we think the number's an integer
		virtual void	DoStripTrailingDecimal( Str255 ioStr, const double iValue );
			
	private:
		NumberParts 		mNumberParts; // the local number parts table
		NumFormatStringRec	mFormat; // the number format for this pane
	};