/*
Copyright  1997 Sailmaker Software Ltd. All rights reserved.
			<mailto:richardb@sailmaker.co.uk>
			<http://www.sailmaker.co.uk/>

File:		CDecimalEditField.h
Author:		Richard Buckle
Purpose:	subclass of CInputField, for decimal numbers
Status:		Copyrighted freeware

See read me for instructions and conditions of use.

*/

#pragma once			/* Include this file only once */

#include "CInputField.h"
#include "CDecimalDescription.h"

class CDecimalEditField : public CInputField, 
							public CDecimalDescription 
	{
	public:
		enum { class_ID = 'Dedt' };
		
		// Instance methods
		CDecimalEditField( LStream *inStream );
		virtual ~CDecimalEditField();
		
		// Public accessors
		virtual double GetDoubleValue();
		virtual void SetDoubleValue( const double iValue );

		// Conform format
		virtual void DoReformatSelf();
		
		// PowerPlant overrides
		virtual void UserChangedText();
		virtual void DontBeTarget();
	
	protected:
		// Get the double value from the text
		virtual double ReadDoubleValue();
		// Put the double value to the text
		virtual void WriteDoubleValue( const double iValue );
	
	private:
		double				mDoubleValue; // cached to avoid unnecessary broadcasting
		Boolean				mStripTrailingDecimal; // if true, then the trailing ".0" is stripped
													// if thethe value is integral
	};