/*
Copyright  1997 Sailmaker Software Ltd. All rights reserved.
			<mailto:richardb@sailmaker.co.uk>
			<http://www.sailmaker.co.uk/>

File:		CDecimalEditText.h
Author:		Richard Buckle
Purpose:	subclass of LEditText, for decimal numbers
Status:		Copyrighted freeware

See read me for instructions and conditions of use.

*/

#pragma once			/* Include this file only once */

#include <LEditText.h>
#include "CDecimalDescription.h"

class CDecimalEditText : public LEditText, 
					public CDecimalDescription 
	{
	public:
		enum { class_ID = 'Detx' };
		
		// Instance methods
		CDecimalEditText( LStream *inStream );
		virtual ~CDecimalEditText();
		
		// Public accessors
		virtual double GetDoubleValue();
		virtual void SetDoubleValue( const double iValue );
		
		// Conform format
		virtual void DoReformatSelf();
		
		// PowerPlant overrides
		virtual void UserChangedText();
		virtual void DontBeTarget();
		
		virtual Boolean	ObeyCommand(
								CommandT			inCommand,
								void				*ioParam);

	protected:
		// Get the double value from the text
		virtual double ReadDoubleValue();
		// Put the double value to the text
		virtual void WriteDoubleValue( const double iValue );
	
	private:
		double		mDoubleValue;// cached to avoid unnecessary broadcasting
		Boolean		mIsChanged; // true if the user has changed contents
		Boolean		mStripTrailingDecimal; // if true, then the trailing ".0" is stripped
											// if the value is integral
	};