/*
Copyright  1997 Sailmaker Software Ltd. All rights reserved.
			<mailto:richardb@sailmaker.co.uk>
			<http://www.sailmaker.co.uk/>

File:		CDecimalStaticText.cp
Author:		Richard Buckle
Purpose:	subclass of LStaticText, for decimal numbers
Status:		Copyrighted freeware

See read me for instructions and conditions of use.

*/

#include "CDecimalStaticText.h"

#pragma mark ----- Instance methods -----
// constructor
CDecimalStaticText::CDecimalStaticText( LStream *inStream )
	: LStaticText( inStream ),
	CDecimalDescription( inStream ),
	mStripTrailingDecimal(false)
	{
	inStream->ReadData(&mStripTrailingDecimal, sizeof(Boolean));
	}
	
// destructor	
CDecimalStaticText::~CDecimalStaticText()
	{}

#pragma mark -
#pragma mark ----- Public accessors -----
// return the value as a double
double CDecimalStaticText::GetDoubleValue()
	{
	Str255 theStr;
	GetDescriptor( theStr );
	return StrToDoubleValue( theStr );
	}
	
// set the value to the given double
void CDecimalStaticText::SetDoubleValue( const double iValue )
	{
	Str255 theStr;
	DoubleValueToStr( theStr, iValue, mStripTrailingDecimal );
	SetDescriptor( theStr );
	}