/*
Copyright  1997 Sailmaker Software Ltd. All rights reserved.
			<mailto:richardb@sailmaker.co.uk>
			<http://www.sailmaker.co.uk/>

File:		CInputField.h
Author:		Richard Buckle
Version:	1.0
Purpose:	subclass of LEditField, broadcasts a message when changed
Status:		Copyrighted freeware

See read me for instructions and conditions of use.

*/

// These days you could also use LBroadcasterEditField for this,
// but I prefer this implementation

#pragma once			/* Include this file only once */

#include <LEditField.h>

class CInputField : public LEditField, 
					public LBroadcaster 
	{
	public:
		
		CInputField( LStream *inStream );
		virtual ~CInputField();
		
		virtual void UserChangedText();
		virtual Boolean	ObeyCommand(
								CommandT			inCommand,
								void				*ioParam);

		virtual void AnnounceChange(); // a surrogate for BraodcastValueMessage
		
	protected:
		Boolean	mIsChanged; // true if the user has changed contents
	};