/*
Copyright  1997 Sailmaker Software Ltd. All rights reserved.
			<mailto:richardb@sailmaker.co.uk>
			<http://www.sailmaker.co.uk/>

File:		CDecimalTestWindow.h
Author:		Richard Buckle
Version:	1.0
Commenced:	25/1/98
Purpose:	test window for decimal edit classes

*/

#pragma once

#include <LWindow.h>
#include <LListener.h>

class	CDecimalStaticText;
class	CDecimalEditText;
class	LSlider;


//----------
class	CDecimalTestWindow :	public LWindow, public LListener {
public:
	// Instance methods 
	enum { class_ID = 'Test' }; 
	static	CDecimalTestWindow*	CreateDecimalTestWindow		(LCommander *inSuperCommander);

						CDecimalTestWindow		(LStream	*inStream);
	virtual				~CDecimalTestWindow();

	// Commands and Messages 
	virtual void		ListenToMessage		(MessageT	inMessage,
											 void		*ioParam);

											 
protected:
	// Implementation 
	static	void		RegisterClass();
	virtual void		FinishCreateSelf();
	
// Members 
protected:
	static Boolean		sIsRegistered;

private:
	CDecimalStaticText	*mLinkedStaticText;
	CDecimalEditText	*mLinkedEditText;
	LSlider				*mLinkedSlider;
	
	
	// default ctor is private
						CDecimalTestWindow();
};
