/*
	model_effects.h
*/

enum {
	MAXIMUM_ACTIVE_MODEL_EFFECTS_PER_MAP= 16,
	INFINITE_DURATION= -1,
	NO_PERMUTATION_CHANGE= -1,
	MAXIMUM_NUMBER_OF_MODEL_EFFECT_PROJECTILE_GROUPS= 4,
	
	_fade_model_in_bit= 0,
	_fade_model_out_bit,
	_delete_model_on_completion_bit,
	_scale_model_bit,
	_create_projectile_bit,
	_permutation_change_only_bit, // allows partial flipping of permutatins (ie calling again..)
	NUMBER_OF_MODEL_EFFECT_BITS,
	
	_fade_model_in_flag= FLAG(_fade_model_in_bit),
	_fade_model_out_flag= FLAG(_fade_model_out_bit),
	_delete_model_on_completion_flag= FLAG(_delete_model_on_completion_bit),
	_scale_model_flag= FLAG(_scale_model_bit),
	_create_projectile_flag= FLAG(_create_projectile_bit),
	_permutation_change_only_flag= FLAG(_permutation_change_only_bit) // allows partial flipping of permutatins (ie calling again..)
};

struct new_model_effect_data {
	word flags;
	short duration; // -1 is infinite
	angle delta_yaw; // per tick
	angle delta_pitch; // per tick
	int new_permutation;
	int set_permutation; // doesn't crossfade to this
	int material_fading_index;
	fixed_fraction material_final_transparency;
	short initial_scale; // (WORLD_ONE/5, 3*WORLD_ONE), WORLD_ONE is unscaled.
	short final_scale;

	// these are created on the first tick.
	world_point3d projectile_origin;
	file_tag projectile_type_to_create;
};

void initialize_model_effects(void);
void initialize_model_effects_for_new_map(void);
void dispose_model_effects_from_old_map(void);

void update_model_effects(void);

boolean new_model_effect(int model_identifier, int map_action_identifier, struct new_model_effect_data *data);

