// =================================================================================
//	C3DMapView.h						1997 eli curtz. All rights reserved.
// =================================================================================

#pragma once

#include <QD3D.h>

class C3DMapView : public LView, public LBroadcaster, public LCommander {
public:
	enum { class_ID = '3DOV' };
	
						C3DMapView();
						C3DMapView(
								LStream				*inStream);
	virtual				~C3DMapView();

	virtual void		ResizeFrameBy(
								Int16				inWidthDelta,
								Int16				inHeightDelta,
								Boolean				inRefresh);
								
	LGWorld*			GetGWorld();
	void				SetGWorld(
								LGWorld				*inGWorld);
	
	TQ3GroupObject		GetMapMesh();
	void				SetMapMesh(
								TQ3GroupObject		inMesh);
	

	virtual void		ClickSelf(
								const SMouseDownEvent &inMouseDown);
	virtual void		HandlePick(
								const SMouseDownEvent &inMouseDown);

	virtual void		SetObjects(
								LArray* inObjects);
	
	virtual void		SetUseTexture(
								Boolean inTexture);
	virtual Boolean		GetUseTexture()
								{ return mRenderTexture; };

	virtual Boolean		HandleKeyPress(
								const EventRecord	&inKeyEvent);
			
			void		CameraOrbit(float inDegrees, float inVerticalDegrees = 0.0);
			void		CameraPan(float inDegrees);
			void		CameraZoom(float inDistance);
			void		CameraMove(float inDistance, float inOrthogonalDistance);

protected:
	Boolean				mRenderTexture;

	virtual void		DrawSelf();
	
	LArray* mObjects;

	LGWorld*			mGWorld;

	TQ3ViewObject		mQD3DView;
	TQ3GroupObject		mQD3DMeshGroup;
	TQ3PickObject		mQD3DPicker;


private:
	void				InitializeView();
};
