// =================================================================================
//	CGorFile.h				1997 eli curtz. All rights reserved.
// =================================================================================

#pragma once

#include <LComparator.h>
#include <LFileStream.h>

#include "gorStuff.h"
#include "gorStructs.h"

class LArray;

class	LTagComparator : public LComparator {
public:
						LTagComparator() { }
	virtual				~LTagComparator() { }
			
	virtual Int32		Compare(
								const void*			inItemOne,
								const void* 		inItemTwo,
								Uint32				inSizeOne,
								Uint32				inSizeTwo) const;
};

class	CGorFile : public LFileStream {

public:
						CGorFile();
						CGorFile(
								const FSSpec	&inFileSpec);
						CGorFile(
								AliasHandle		inAlias,
								Boolean			&outWasChanged,
								FSSpec			*inFromFile = nil);
	virtual				~CGorFile();
	
	virtual Boolean		SegmentExists(FourCharCode inGroup, FourCharCode inSubGroup);
	virtual	Boolean		GetSegmentHeader(FourCharCode inGroup, FourCharCode inSubGroup, dir_Header* outHeader);
	virtual	Handle		GetSegment(FourCharCode inGroup, FourCharCode inSubGroup);

protected:
	gor_Header			mHeader;
	LArray*				mSegmentList;

	Boolean				mInitialized;
	void				Initialize();
};
