// =================================================================================
//	CMapDocument.h					1997 eli curtz. All rights reserved.
// =================================================================================

#pragma once

#include <LSingleDoc.h>
#include <LListener.h>
#include <LComparator.h>

#include <QD3D.h>

class CMapView;
class C3DMapView;
class LArray;
class LString;

#include "gorStuff.h"
#include "gorStructs.h"

struct command_Storage {
	mesh_Command	theCommand;
	Int16			theCommandID;
	LString *		theCommandName;
}; typedef struct command_Storage command_Storage;

class CMapDocument : public LSingleDoc, public LListener {
public:
						CMapDocument( LCommander *inSuper, FSSpec *inFileSpec, LArray* inFileArray = nil);
	virtual				~CMapDocument();
	
	virtual Boolean		IsModified();
	
	virtual void		DoAESave( FSSpec &inFileSpec, OSType inFileType );
	virtual void		DoSave();
	virtual void		DoRevert();
	virtual void		DoPrint();

	virtual void		ListenToMessage(MessageT inMessage, void *ioParam);

	virtual Boolean		ObeyCommand(
								CommandT			inCommand,
								void				*ioParam);
	virtual void		FindCommandStatus(
								CommandT			inCommand,
								Boolean				&outEnabled,
								Boolean				&outUsesMark,
								Char16				&outMark,
								Str255				outName);

protected:
	CMapView *			mOutputView;

	void				NameNewDoc();
	void				SetPrintFrameSize(void);
	
	void				ShowPreferencesDialog();
	
	void				OpenFile( FSSpec &inFileSpec );
	void				BuildGWorld();
	void				BuildQD3DGroup();
	
	void				ImportHeightMap();

private:
	LFileStream *		mFileStream; // screw casting mFile all the time
	
	mesh_Header			mMeshHeader;
	Int32				mHeaderOffset;
	
	LArray*				mObjects;
	LArray*				mLocalSourceFiles;
	LArray*				mGlobalSourceFiles;
	
	Int32				mObjectIndex;
	
	LGWorld*			mTextureGWorld;
	TQ3GroupObject		mQD3DMapMesh;
	
	CMapView*			mMapView;
	C3DMapView*			m3DMapView;
};