// ===========================================================================
//	UQuickDraw3D.h			   1997 eli curtz. All rights reserved.
// ===========================================================================

#ifndef _H_UQuickDraw3D
#define _H_UQuickDraw3D
#pragma once

#include <LPane.h>
#include <LPeriodical.h>

#ifndef QD3D_h
#include <QD3D.h>
#endif
#ifndef QD3DViewer_h
#include <QD3DViewer.h>
#endif

// ---------------------------------------------------------------------------

class	UQuickDraw3D {
public:
	static Boolean	QuickDraw3DIsPresent();
	static void		Initialize();
	static void		Finalize();
	
private:
	static Boolean	sQuickDraw3DPresent;
};

// ---------------------------------------------------------------------------

class	LQD3DViewer : public LPane {
public:
	enum { class_ID = 'QD3d' };
	
						LQD3DViewer();
						LQD3DViewer(LStream *inStream);
	virtual				~LQD3DViewer();

	virtual void		FinishCreateSelf();
	virtual void		DrawSelf();
	
	virtual void		AdjustCursorSelf(Point inPortPt, const EventRecord &inMacEvent);
	virtual void		ResizeFrameBy(Int16	inWidthDelta, Int16	inHeightDelta, Boolean inRefresh);
	virtual void		ClickSelf(const SMouseDownEvent &inMouseDown);
	
	virtual void		SetSourceFile(LFile* inSourceFile);
	virtual void		SetSourceData(Handle inSourceData);
	virtual void		SetGroup(TQ3GroupObject inGroup);
	
	virtual TQ3ViewObject	GetView();

	virtual void		SaveToFile(LFile* inDestinationFile = nil);

protected:
	TQ3ViewerObject		mViewerObject;

	LFile*				mSourceFile;
	Handle				mSourceData;

	Boolean				HandleViewerEvent(EventRecord &inMacEvent);
};

#endif