// =================================================================================
// CModelManager.h
// =================================================================================


#pragma once


#include "PiriReisTypes.h"

#include <QD3D.h>
#include <QD3DGeometry.h>

struct SModelInfo
{
	FourCharCode			fModelTag;
	
	model_definition		fModelHeader;
	geometry_definition		fGeometryHeader;
	
	TArray<TQ3GroupObject>	*fPermutations;
};

class CModelManager : public LListener
{
public:
							CModelManager();
	virtual					~CModelManager();

			void			Open( FourCharCode  inTagID );
			
			Boolean			IsDirty()
							{ return false; }
								  
	virtual	void			ListenToMessage( MessageT inMessage, void *ioParam );
		
	virtual TQ3GroupObject	GetModel( FourCharCode inTagID, Int32 inPermutation = 0 );
	
protected:
	TArray<SModelInfo>		fModelArray;
	
	virtual ArrayIndexT		BuildModelData( FourCharCode inTagID );
};