// =================================================================================
//	CfontDocument.h					1997 eli curtz. All rights reserved.
// =================================================================================

#pragma once

#include <LSingleDoc.h>
#include <LListener.h>

#include "gorStuff.h"
#include "gorStructs.h"

class CfontView;

class CfontDocument : public LSingleDoc, public LListener {
public:
						CfontDocument( LCommander *inSuper, FSSpec *inFileSpec );

	virtual Boolean		IsModified();
	
	virtual void		DoAESave( FSSpec &inFileSpec, OSType inFileType );
	virtual void		DoSave();
	virtual void		DoRevert();
	virtual void		DoPrint();

	virtual void		ListenToMessage(MessageT inMessage, void *ioParam);

protected:
	CfontView *			mfontView;

	void				NameNewDoc();
	void				OpenFile( FSSpec &inFileSpec );
	void				SetPrintFrameSize(void);

private:
	LFileStream *		mFileStream; // screw casting mFile all the time
	
	font_Header			mfontHeader;
	Int32				mHeaderOffset;
};