// ===========================================================================
//	CfontView.cp				   1993-1997 eli curtz. All rights reserved.
// ===========================================================================
//

#ifdef PowerPlant_PCH
#include PowerPlant_PCH
#endif

#include <LPicture.h>
#include <LStream.h>
#include <UDrawingState.h>

#include "CfontView.h"

// ---------------------------------------------------------------------------
//	 CfontView						Default Constructor		  [public]
// ---------------------------------------------------------------------------

CfontView::CfontView()
		: LQD3DViewer()
{
	mVertexPicker = nil;
}


// ---------------------------------------------------------------------------
//	 CfontView(LStream*)			Stream Constructor	  [public]
// ---------------------------------------------------------------------------

CfontView::CfontView(
	LStream	*inStream)
		: LQD3DViewer(inStream)
{
	mVertexPicker = nil;
}


// ----------------------------------------------------------------------------
//   FinishCreateSelf												[public]
// ----------------------------------------------------------------------------

void
CfontView::FinishCreateSelf()	
{
	inherited::FinishCreateSelf();
	
	unsigned long viewerFlags = ::Q3ViewerGetFlags(mViewerObject);
		// Disable drag & drop
	::Q3ViewerSetFlags(mViewerObject, viewerFlags | kQ3ViewerDraggingOff);

	TQ3WindowPointPickData theData;
	theData.data.sort = kQ3PickSortNearToFar;
	theData.data.mask = kQ3PickDetailMaskObject | kQ3PickDetailMaskXYZ | kQ3PickDetailMaskUV;
	theData.data.numHitsToReturn = kQ3ReturnAllHits;
	theData.point.x = 0;
	theData.point.y = 0;
	theData.vertexTolerance = 0.1;
	theData.edgeTolerance = 0.1;

	mVertexPicker = ::Q3WindowPointPick_New(&theData);
	if (mVertexPicker == nil)	{
		SignalPStr_("\pCouldn't create vertex picker");
	}
}


// ----------------------------------------------------------------------------
//	 ClickSelf												[public]
// ----------------------------------------------------------------------------

void
CfontView::ClickSelf(const SMouseDownEvent &inMouseDown)	
{
/*	unsigned long bsState = ::Q3ViewerGetCurrentButton(mViewerObject);
	if (mVertexPicker && mViewerObject && (bsState == kQ3ViewerButtonDolly)) {
// ?
OSErr theErr = ::Q3ViewerSetCurrentButton(mViewerObject, kQ3ViewerButtonZoom);
		TQ3Point2D qd3DWhere;
		qd3DWhere.x = inMouseDown.wherePort.h;
		qd3DWhere.y = inMouseDown.wherePort.v;
		
		TQ3Status qd3DStatus = ::Q3WindowPointPick_SetPoint(mVertexPicker, &qd3DWhere);
		if (qd3DStatus != kQ3Success)
			SignalPStr_("\pCouldn't set picker point for Peter");
		
		TQ3ViewObject qd3DView = ::Q3ViewerGetView(mViewerObject); 
		TQ3GroupObject qd3DGroup = ::Q3ViewerGetGroup(mViewerObject);
		
		if (qd3DView && qd3DGroup) {
			::Q3View_StartPicking(qd3DView, mVertexPicker);
			if (qd3DStatus != kQ3Success)
				SignalPStr_("\pCouldn't start picking");

			do {
				::Q3DisplayGroup_Submit(qd3DGroup, qd3DView);
			} while (::Q3View_EndPicking(qd3DView) == kQ3ViewStatusRetraverse);
			
			unsigned long hitCount = 0;
			qd3DStatus = ::Q3Pick_GetNumHits(mVertexPicker, &hitCount);
			if (qd3DStatus != kQ3Success)
				SignalPStr_("\pCouldn't get hit list");
			
			TQ3PickDetail qd3DHitDetail;
			TQ3Object qd3DHitObject = nil;
			TQ3Param2D qd3DUVParam;
			TQ3Point3D qd3DXYZPoint;
			for (unsigned long hitIndex = 0; hitIndex < hitCount; hitIndex++) {
				qd3DStatus = ::Q3Pick_GetPickDetailValidMask (mVertexPicker, hitIndex, &qd3DHitDetail);
				if (qd3DStatus != kQ3Success)
					SignalPStr_("\pBad hit data");
				
				if (qd3DHitDetail & kQ3PickDetailMaskXYZ) {
					qd3DStatus = ::Q3Pick_GetPickDetailData (mVertexPicker, hitIndex, kQ3PickDetailMaskXYZ, &qd3DXYZPoint);
					if (qd3DStatus != kQ3Success)
						SignalPStr_("\pBad UV from hit");
				}

				if (qd3DHitDetail & kQ3PickDetailMaskUV) {
					qd3DStatus = ::Q3Pick_GetPickDetailData (mVertexPicker, hitIndex, kQ3PickDetailMaskUV, &qd3DUVParam);
					if (qd3DStatus != kQ3Success)
						SignalPStr_("\pBad UV from hit");
				}
			}
			
			::Q3Pick_EmptyHitList(mVertexPicker);
		}
	}
	else
*/
		inherited::ClickSelf(inMouseDown);
}

