// =================================================================================
//	CcommandDocument.h					1997 eli curtz. All rights reserved.
// =================================================================================

#pragma once

#include <LSingleDoc.h>
#include <LListener.h>
#include <LComparator.h>

class LTextEditView;
class LArray;
class LString;

#include "gorStuff.h"
#include "gorStructs.h"
//#include "mesh_file.h"

struct command_Storage {
	mesh_Command	theCommand;
	Int16			theCommandID;
	LString *		theCommandName;
}; typedef struct command_Storage command_Storage;

class	LCommandComparator : public LComparator {
public:
						LCommandComparator() { }
	virtual				~LCommandComparator() { }
			
	virtual Int32		Compare(
								const void*			inItemOne,
								const void* 		inItemTwo,
								Uint32				inSizeOne,
								Uint32				inSizeTwo) const;
};

class CcommandDocument : public LSingleDoc, public LListener {
public:
						CcommandDocument( LCommander *inSuper, FSSpec *inFileSpec );
	virtual				~CcommandDocument();
	
	virtual Boolean		IsModified();
	
	virtual void		DoAESave( FSSpec &inFileSpec, OSType inFileType );
	virtual void		DoSave();
	virtual void		DoRevert();
	virtual void		DoPrint();

	virtual void		ListenToMessage(MessageT inMessage, void *ioParam);

protected:
	LTextEditView *		mOutputView;

	void				NameNewDoc();
	void				OpenFile( FSSpec &inFileSpec );
	void				SetPrintFrameSize(void);

private:
	LFileStream *		mFileStream; // screw casting mFile all the time
	
	mesh_Header			mMeshHeader;
	Int32				mHeaderOffset;
	
	LArray*				mCommandArray;
};