// =================================================================================
//	CmeshDocument.h					1997 eli curtz. All rights reserved.
// =================================================================================

#pragma once

#include <LSingleDoc.h>
#include <LListener.h>

#include "gorStuff.h"
#include "gorStructs.h"

class CmeshView;

class CmeshDocument : public LSingleDoc, public LListener {
public:
						CmeshDocument( LCommander *inSuper, FSSpec *inFileSpec );

	virtual Boolean		IsModified();
	
	virtual void		DoAESave( FSSpec &inFileSpec, OSType inFileType );
	virtual void		DoSave();
	virtual void		DoRevert();
	virtual void		DoPrint();

	virtual void		ListenToMessage(MessageT inMessage, void *ioParam);

protected:
	CmeshView *			mMeshView;

	void				NameNewDoc();
	void				OpenFile( FSSpec &inFileSpec );
	void				SetPrintFrameSize(void);

private:
	LFileStream *		mFileStream; // screw casting mFile all the time
	
	mesh_Header			mMeshHeader;
	Int32				mHeaderOffset;

	LFileStream*		FindTextureFile(FSSpec &inFileSpec );
	void				AddMapTexture(TQ3GroupObject& ioGroup, LFileStream* inFile);
};