// ===========================================================================
//	CMiniIconTable.cp		   1995-1997 Metrowerks Inc. All rights reserved.
// ===========================================================================

#include <LTableMonoGeometry.h>
#include <LTableSingleSelector.h>
#include <LTableArrayStorage.h>

#ifndef __ICONS__
#include <Icons.h>
#endif

#include "CMiniIconTable.h"

CMiniIconTable::CMiniIconTable(
	LStream	*inStream)
		: LTableView(inStream)
{
	mTableGeometry = new LTableMonoGeometry(this, mFrameSize.width, 16);
	mTableSelector = new LTableSingleSelector(this);
	mTableStorage = new LTableArrayStorage(this, sizeof(MIconTableRec));
}


CMiniIconTable::~CMiniIconTable()
{
}


void
CMiniIconTable::DrawCell(
	const STableCell	&inCell,
	const Rect			&inLocalRect)
{
	MIconTableRec	iconAndName;
	Uint32			dataSize = sizeof(MIconTableRec);
	GetCellData(inCell, &iconAndName, dataSize);
	
	Rect	iconRect;
	iconRect.left = inLocalRect.left + 3;
	iconRect.right = iconRect.left + 16;
	iconRect.bottom = inLocalRect.bottom - 2;
	iconRect.top = iconRect.bottom - 12;
	::PlotIconID(&iconRect, atNone, ttNone, iconAndName.iconID);
	
	::TextSize(9);
	::TextFont(1);
	::MoveTo(inLocalRect.left + 20, inLocalRect.bottom - 4);
	::DrawString(iconAndName.name);
}