// =================================================================================
//	CobjectDocument.h					1997 eli curtz. All rights reserved.
// =================================================================================

#pragma once

#include <LSingleDoc.h>
#include <LListener.h>
#include <LComparator.h>

class CobjectView;
class LArray;
class LString;

#include "gorStuff.h"
#include "gorStructs.h"
//#include "mesh_file.h"

struct command_Storage {
	mesh_Command	theCommand;
	Int16			theCommandID;
	LString *		theCommandName;
}; typedef struct command_Storage command_Storage;

class	LTagComparator : public LComparator {
public:
						LTagComparator() { }
	virtual				~LTagComparator() { }
			
	virtual Int32		Compare(
								const void*			inItemOne,
								const void* 		inItemTwo,
								Uint32				inSizeOne,
								Uint32				inSizeTwo) const;
};

class CobjectDocument : public LSingleDoc, public LListener {
public:
						CobjectDocument( LCommander *inSuper, FSSpec *inFileSpec );
	virtual				~CobjectDocument();
	
	virtual Boolean		IsModified();
	
	virtual void		DoAESave( FSSpec &inFileSpec, OSType inFileType );
	virtual void		DoSave();
	virtual void		DoRevert();
	virtual void		DoPrint();

	virtual void		ListenToMessage(MessageT inMessage, void *ioParam);

	virtual Boolean		ObeyCommand(
								CommandT			inCommand,
								void				*ioParam);
	virtual void		FindCommandStatus(
								CommandT			inCommand,
								Boolean				&outEnabled,
								Boolean				&outUsesMark,
								Char16				&outMark,
								Str255				outName);
	

protected:
	CobjectView *		mOutputView;

	void				NameNewDoc();
	void				OpenFile( FSSpec &inFileSpec );
	void				SetPrintFrameSize(void);
	
	void				ShowPreferencesDialog();

private:
	LFileStream *		mFileStream; // screw casting mFile all the time
	
	mesh_Header			mMeshHeader;
	Int32				mHeaderOffset;
	
	LArray*				mObjectTypes[16];
	LArray*				mTags;
	
	Int32				mObjectIndex;
	
	LStdControl*		mNextButton;
	LStdControl*		mPreviousButton;
	
	LCaption*			mTypeCaption;
	LCaption*			mTeamCaption;
	LCaption*			mXPosCaption;
	LCaption*			mYPosCaption;
	LCaption*			mZPosCaption;
	LCaption*			mFacingCaption;
	LCaption*			mObjectIDCaption;
	LStdControl*		mHiddenCheck;
	
	LGWorld*			mMapGWorld;
};